# -*- coding: utf-8 -*-
# Import the PyQt and QGIS libraries
from qgis.PyQt.QtCore import *
from qgis.PyQt.QtGui import *
from qgis.PyQt.QtWidgets import *
from qgis.core import *

from qgis.PyQt.QtCore import QUrl
from qgis.PyQt.QtNetwork import QNetworkReply, QNetworkRequest


class HelloWorld(object):

    def __init__(self, iface):
        # Save reference to the QGIS interface
        self.iface = iface
        self.canvas = iface.mapCanvas()

    def initGui(self):
        # Create action that will start plugin
        self.action = QAction(QIcon(":/plugins/"), "&HelloWorld", self.iface.mainWindow())

        # connect the action to the work/run method
        self.action.triggered.connect(self.hello_world)

        # Add toolbar button and menu item
        self.iface.addPluginToMenu("HelloWorld", self.action)


    def unload(self):
        # Remove the plugin menu item and icon
        self.iface.removePluginMenu("HelloWorld",self.action)

    # run
    def hello_world(self):
        request = QgsBlockingNetworkRequest()
        err = request.get(QNetworkRequest(QUrl('https://duif.net')), True)
        QgsMessageLog.logMessage(f'err = {err}')
        reply = request.reply()
        QgsMessageLog.logMessage(f'response = {reply.content()}')
        QMessageBox.information(self.iface.mainWindow(), 'Response', f'Response (should be "ok"): {reply.content()}')



if __name__ == "__main__":
    pass
